/*----- PROTECTED REGION ID(DSManagerTest.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        DSManagerTest.cpp
//
// description : C++ source for the DSManagerTest class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               DSManagerTest are implemented in this file.
//
// project :     DSManagerTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <DSManagerTest.h>
#include <DSManagerTestClass.h>

/*----- PROTECTED REGION END -----*/	//	DSManagerTest.cpp

/**
 *  DSManagerTest class description:
 *    DSManagerTest
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  ds_mode             |  Tango::DevEnum	Scalar
//  ds_powerState       |  Tango::DevEnum	Scalar
//  ind_Position        |  Tango::DevEnum	Scalar
//  ds_mode_test        |  Tango::DevEnum	Scalar
//  ds_powerState_test  |  Tango::DevEnum	Scalar
//  stowStatus          |  Tango::DevString	Spectrum  ( max = 2)
//  indexingStatus      |  Tango::DevString	Spectrum  ( max = 2)
//================================================================

namespace DSManagerTest_ns
{
/*----- PROTECTED REGION ID(DSManagerTest::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	DSManagerTest::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : DSManagerTest::DSManagerTest()
 *	Description : Constructors for a Tango device
 *                implementing the classDSManagerTest
 */
//--------------------------------------------------------
DSManagerTest::DSManagerTest(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(DSManagerTest::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::constructor_1
}
//--------------------------------------------------------
DSManagerTest::DSManagerTest(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(DSManagerTest::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::constructor_2
}
//--------------------------------------------------------
DSManagerTest::DSManagerTest(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(DSManagerTest::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : DSManagerTest::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void DSManagerTest::delete_device()
{
	DEBUG_STREAM << "DSManagerTest::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::delete_device
	delete[] attr_ds_mode_read;
	delete[] attr_ds_powerState_read;
	delete[] attr_ind_Position_read;
	delete[] attr_ds_mode_test_read;
	delete[] attr_ds_powerState_test_read;
	delete[] attr_stowStatus_read;
	delete[] attr_indexingStatus_read;
}

//--------------------------------------------------------
/**
 *	Method      : DSManagerTest::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void DSManagerTest::init_device()
{
	DEBUG_STREAM << "DSManagerTest::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::init_device_before
	
	//	No device property to be read from database
	
	attr_ds_mode_read = new ds_modeEnum[1];
	attr_ds_powerState_read = new ds_powerStateEnum[1];
	attr_ind_Position_read = new ind_PositionEnum[1];
	attr_ds_mode_test_read = new ds_mode_testEnum[1];
	attr_ds_powerState_test_read = new ds_powerState_testEnum[1];
	attr_stowStatus_read = new Tango::DevString[2];
	attr_indexingStatus_read = new Tango::DevString[2];
	/*----- PROTECTED REGION ID(DSManagerTest::init_device) ENABLED START -----*/
	
	//	Initialize device
	*attr_ds_mode_read= ds_modeEnum::_UNKNOWN;
	*attr_ds_powerState_read= ds_powerStateEnum::_LOWminusPOWER;
	*attr_ind_Position_read= ind_PositionEnum::_B1;
	*attr_ds_mode_test_read= ds_mode_testEnum::_OFF;
	*attr_ds_powerState_test_read= ds_powerState_testEnum::_FULLminusPOWER;
	

	attr_stowStatus_read[0]= Tango::string_dup("INIT");
	attr_stowStatus_read[1]= Tango::string_dup("No info present");

	attr_indexingStatus_read[0]= Tango::string_dup("INIT");
	attr_indexingStatus_read[1]= Tango::string_dup("No info present");
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::init_device
}


//--------------------------------------------------------
/**
 *	Method      : DSManagerTest::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void DSManagerTest::always_executed_hook()
{
	DEBUG_STREAM << "DSManagerTest::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : DSManagerTest::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void DSManagerTest::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "DSManagerTest::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute ds_mode related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (ds_modeEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void DSManagerTest::read_ds_mode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DSManagerTest::read_ds_mode(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::read_ds_mode) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ds_mode_read);
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::read_ds_mode
}
//--------------------------------------------------------
/**
 *	Read attribute ds_powerState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (ds_powerStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void DSManagerTest::read_ds_powerState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DSManagerTest::read_ds_powerState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::read_ds_powerState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ds_powerState_read);
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::read_ds_powerState
}
//--------------------------------------------------------
/**
 *	Read attribute ind_Position related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (ind_PositionEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void DSManagerTest::read_ind_Position(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DSManagerTest::read_ind_Position(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::read_ind_Position) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ind_Position_read);
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::read_ind_Position
}
//--------------------------------------------------------
/**
 *	Read attribute ds_mode_test related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (ds_mode_testEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void DSManagerTest::read_ds_mode_test(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DSManagerTest::read_ds_mode_test(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::read_ds_mode_test) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ds_mode_test_read);
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::read_ds_mode_test
}
//--------------------------------------------------------
/**
 *	Read attribute ds_powerState_test related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (ds_powerState_testEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void DSManagerTest::read_ds_powerState_test(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DSManagerTest::read_ds_powerState_test(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::read_ds_powerState_test) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ds_powerState_test_read);
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::read_ds_powerState_test
}
//--------------------------------------------------------
/**
 *	Read attribute stowStatus related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2
 */
//--------------------------------------------------------
void DSManagerTest::read_stowStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DSManagerTest::read_stowStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::read_stowStatus) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_stowStatus_read, 2);
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::read_stowStatus
}
//--------------------------------------------------------
/**
 *	Read attribute indexingStatus related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2
 */
//--------------------------------------------------------
void DSManagerTest::read_indexingStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DSManagerTest::read_indexingStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(DSManagerTest::read_indexingStatus) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_indexingStatus_read, 2);
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::read_indexingStatus
}

//--------------------------------------------------------
/**
 *	Method      : DSManagerTest::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void DSManagerTest::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(DSManagerTest::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : DSManagerTest::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void DSManagerTest::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(DSManagerTest::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTest::add_dynamic_commands
}

/*----- PROTECTED REGION ID(DSManagerTest::namespace_ending) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	DSManagerTest::namespace_ending
} //	namespace
