/*----- PROTECTED REGION ID(DSManagerTest.h) ENABLED START -----*/
//=============================================================================
//
// file :        DSManagerTest.h
//
// description : Include file for the DSManagerTest class
//
// project :     DSManagerTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef DSManagerTest_H
#define DSManagerTest_H

#include <tango.h>


/*----- PROTECTED REGION END -----*/	//	DSManagerTest.h

/**
 *  DSManagerTest class description:
 *    DSManagerTest
 */

namespace DSManagerTest_ns
{
enum class _ds_modeEnum : short {
	_OFF,
	_STARTUP,
	_STANDBYminusLP,
	_STOW,
	_ESTOP,
	_POINT,
	_MAINTENANCE,
	_UNKNOWN,
	_STANDBYminusFP,
} ;
typedef _ds_modeEnum ds_modeEnum;

enum class _ds_powerStateEnum : short{
	_OFF,
	_LOWminusPOWER,
	_FULLminusPOWER,
} ;
typedef _ds_powerStateEnum ds_powerStateEnum;

enum class _ind_PositionEnum : short{
	_B1,
	_B2,
	_B3,
	_B4,
	_B5,
	_MOVING,
	_ERROR,
	_UNKNOWN,
} ;
typedef _ind_PositionEnum ind_PositionEnum;

enum class _ds_mode_testEnum : short {
	_OFF,
	_STARTUP,
	_STANDBY,
	_STOW,
	_ESTOP,
	_POINT,
	_MAINTENANCE,
	_ERROR,
	_UNKNOWN,
} ;
typedef _ds_mode_testEnum ds_mode_testEnum;

enum class _ds_powerState_testEnum : short {
	_UPS,
	_FULLminusPOWER,
	_LOWminusPOWER,
	_UNKNOWN,
} ;
typedef _ds_powerState_testEnum ds_powerState_testEnum;

/*----- PROTECTED REGION ID(DSManagerTest::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	DSManagerTest::Additional Class Declarations

class DSManagerTest : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(DSManagerTest::Data Members) ENABLED START -----*/

//	Add your own data members

/*----- PROTECTED REGION END -----*/	//	DSManagerTest::Data Members


//	Attribute data members
public:
	ds_modeEnum	*attr_ds_mode_read;
	ds_powerStateEnum	*attr_ds_powerState_read;
	ind_PositionEnum	*attr_ind_Position_read;
	ds_mode_testEnum	*attr_ds_mode_test_read;
	ds_powerState_testEnum	*attr_ds_powerState_test_read;
	Tango::DevString	*attr_stowStatus_read;
	Tango::DevString	*attr_indexingStatus_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	DSManagerTest(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	DSManagerTest(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	DSManagerTest(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~DSManagerTest() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : DSManagerTest::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute ds_mode related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_ds_mode(Tango::Attribute &attr);
	virtual bool is_ds_mode_allowed(Tango::AttReqType type);
/**
 *	Attribute ds_powerState related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_ds_powerState(Tango::Attribute &attr);
	virtual bool is_ds_powerState_allowed(Tango::AttReqType type);
/**
 *	Attribute ind_Position related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_ind_Position(Tango::Attribute &attr);
	virtual bool is_ind_Position_allowed(Tango::AttReqType type);
/**
 *	Attribute ds_mode_test related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_ds_mode_test(Tango::Attribute &attr);
	virtual bool is_ds_mode_test_allowed(Tango::AttReqType type);
/**
 *	Attribute ds_powerState_test related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_ds_powerState_test(Tango::Attribute &attr);
	virtual bool is_ds_powerState_test_allowed(Tango::AttReqType type);
/**
 *	Attribute stowStatus related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2
 */
	virtual void read_stowStatus(Tango::Attribute &attr);
	virtual bool is_stowStatus_allowed(Tango::AttReqType type);
/**
 *	Attribute indexingStatus related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2
 */
	virtual void read_indexingStatus(Tango::Attribute &attr);
	virtual bool is_indexingStatus_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : DSManagerTest::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method      : DSManagerTest::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(DSManagerTest::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

/*----- PROTECTED REGION END -----*/	//	DSManagerTest::Additional Method prototypes
};

/*----- PROTECTED REGION ID(DSManagerTest::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	DSManagerTest::Additional Classes Definitions

}	//	End of namespace

#endif   //	DSManagerTest_H
