/*----- PROTECTED REGION ID(DSManagerTestClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        DSManagerTestClass.h
//
// description : Include for the DSManagerTest root class.
//               This class is the singleton class for
//                the DSManagerTest device class.
//               It contains all properties and methods which the 
//               DSManagerTest requires only once e.g. the commands.
//
// project :     DSManagerTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef DSManagerTestClass_H
#define DSManagerTestClass_H

#include <tango.h>
#include <DSManagerTest.h>


/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass.h


namespace DSManagerTest_ns
{
/*----- PROTECTED REGION ID(DSManagerTestClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute ds_mode class definition
class ds_modeAttrib: public Tango::Attr
{
public:
	ds_modeAttrib():Attr("ds_mode",
			Tango::DEV_ENUM, Tango::READ) {};
	~ds_modeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DSManagerTest *>(dev))->read_ds_mode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DSManagerTest *>(dev))->is_ds_mode_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(ds_modeEnum) == in_type;}
	virtual string get_enum_type() {return string("ds_modeEnum");}
};

//	Attribute ds_powerState class definition
class ds_powerStateAttrib: public Tango::Attr
{
public:
	ds_powerStateAttrib():Attr("ds_powerState",
			Tango::DEV_ENUM, Tango::READ) {};
	~ds_powerStateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DSManagerTest *>(dev))->read_ds_powerState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DSManagerTest *>(dev))->is_ds_powerState_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(ds_powerStateEnum) == in_type;}
	virtual string get_enum_type() {return string("ds_powerStateEnum");}
};

//	Attribute ind_Position class definition
class ind_PositionAttrib: public Tango::Attr
{
public:
	ind_PositionAttrib():Attr("ind_Position",
			Tango::DEV_ENUM, Tango::READ) {};
	~ind_PositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DSManagerTest *>(dev))->read_ind_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DSManagerTest *>(dev))->is_ind_Position_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(ind_PositionEnum) == in_type;}
	virtual string get_enum_type() {return string("ind_PositionEnum");}
};

//	Attribute ds_mode_test class definition
class ds_mode_testAttrib: public Tango::Attr
{
public:
	ds_mode_testAttrib():Attr("ds_mode_test",
			Tango::DEV_ENUM, Tango::READ) {};
	~ds_mode_testAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DSManagerTest *>(dev))->read_ds_mode_test(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DSManagerTest *>(dev))->is_ds_mode_test_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(ds_mode_testEnum) == in_type;}
	virtual string get_enum_type() {return string("ds_mode_testEnum");}
};

//	Attribute ds_powerState_test class definition
class ds_powerState_testAttrib: public Tango::Attr
{
public:
	ds_powerState_testAttrib():Attr("ds_powerState_test",
			Tango::DEV_ENUM, Tango::READ) {};
	~ds_powerState_testAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DSManagerTest *>(dev))->read_ds_powerState_test(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DSManagerTest *>(dev))->is_ds_powerState_test_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(ds_powerState_testEnum) == in_type;}
	virtual string get_enum_type() {return string("ds_powerState_testEnum");}
};

//	Attribute stowStatus class definition
class stowStatusAttrib: public Tango::SpectrumAttr
{
public:
	stowStatusAttrib():SpectrumAttr("stowStatus",
			Tango::DEV_STRING, Tango::READ, 2) {};
	~stowStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DSManagerTest *>(dev))->read_stowStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DSManagerTest *>(dev))->is_stowStatus_allowed(ty);}
};

//	Attribute indexingStatus class definition
class indexingStatusAttrib: public Tango::SpectrumAttr
{
public:
	indexingStatusAttrib():SpectrumAttr("indexingStatus",
			Tango::DEV_STRING, Tango::READ, 2) {};
	~indexingStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DSManagerTest *>(dev))->read_indexingStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DSManagerTest *>(dev))->is_indexingStatus_allowed(ty);}
};


/**
 *	The DSManagerTestClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  DSManagerTestClass : public Tango::DeviceClass
#else
class DSManagerTestClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(DSManagerTestClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	DSManagerTestClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static DSManagerTestClass *init(const char *);
		static DSManagerTestClass *instance();
		~DSManagerTestClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		DSManagerTestClass(string &);
		static DSManagerTestClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	DSManagerTest_H
