/*----- PROTECTED REGION ID(RxEmulatorTest.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        RxEmulatorTest.cpp
//
// description : C++ source for the RxEmulatorTest class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               RxEmulatorTest are implemented in this file.
//
// project :     RxEmulatorTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <RxEmulatorTest.h>
#include <RxEmulatorTestClass.h>

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest.cpp

/**
 *  RxEmulatorTest class description:
 *    RxEmulatorTest
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  rx_mode              |  Tango::DevEnum	Scalar
//  b1_capabilityState   |  Tango::DevEnum	Scalar
//  b2_capabilityState   |  Tango::DevEnum	Scalar
//  b3_capabilityState   |  Tango::DevEnum	Scalar
//  b4_capabilityState   |  Tango::DevEnum	Scalar
//  b5_capabilityState   |  Tango::DevEnum	Scalar
//  rx_mode_test         |  Tango::DevEnum	Scalar
//  configureBandStatus  |  Tango::DevString	Spectrum  ( max = 2)
//================================================================

namespace RxEmulatorTest_ns
{
/*----- PROTECTED REGION ID(RxEmulatorTest::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::RxEmulatorTest()
 *	Description : Constructors for a Tango device
 *                implementing the classRxEmulatorTest
 */
//--------------------------------------------------------
RxEmulatorTest::RxEmulatorTest(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(RxEmulatorTest::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::constructor_1
}
//--------------------------------------------------------
RxEmulatorTest::RxEmulatorTest(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(RxEmulatorTest::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::constructor_2
}
//--------------------------------------------------------
RxEmulatorTest::RxEmulatorTest(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(RxEmulatorTest::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void RxEmulatorTest::delete_device()
{
	DEBUG_STREAM << "RxEmulatorTest::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::delete_device
	delete[] attr_rx_mode_read;
	delete[] attr_b1_capabilityState_read;
	delete[] attr_b2_capabilityState_read;
	delete[] attr_b3_capabilityState_read;
	delete[] attr_b4_capabilityState_read;
	delete[] attr_b5_capabilityState_read;
	delete[] attr_rx_mode_test_read;
	delete[] attr_configureBandStatus_read;
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void RxEmulatorTest::init_device()
{
	DEBUG_STREAM << "RxEmulatorTest::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::init_device_before
	
	//	No device property to be read from database
	
	attr_rx_mode_read = new rx_modeEnum[1];
	attr_b1_capabilityState_read = new b1_capabilityStateEnum[1];
	attr_b2_capabilityState_read = new b2_capabilityStateEnum[1];
	attr_b3_capabilityState_read = new b3_capabilityStateEnum[1];
	attr_b4_capabilityState_read = new b4_capabilityStateEnum[1];
	attr_b5_capabilityState_read = new b5_capabilityStateEnum[1];
	attr_rx_mode_test_read = new rx_mode_testEnum[1];
	attr_configureBandStatus_read = new Tango::DevString[2];
	/*----- PROTECTED REGION ID(RxEmulatorTest::init_device) ENABLED START -----*/
	
	//	Initialize device
	*attr_rx_mode_read= rx_modeEnum::_UNKNOWN;
	*attr_b1_capabilityState_read= b1_capabilityStateEnum::_UNKNOWN;	
	*attr_b2_capabilityState_read= b2_capabilityStateEnum::_UNKNOWN;	
	*attr_b3_capabilityState_read= b3_capabilityStateEnum::_UNKNOWN;	
	*attr_b4_capabilityState_read= b4_capabilityStateEnum::_UNKNOWN;	
	*attr_b5_capabilityState_read= b5_capabilityStateEnum::_UNKNOWN;	
	*attr_rx_mode_test_read= rx_mode_testEnum::_UNKNOWN;

	attr_configureBandStatus_read[0]= Tango::string_dup("INIT");
	attr_configureBandStatus_read[1]= Tango::string_dup("No info present");
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::init_device
}


//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void RxEmulatorTest::always_executed_hook()
{
	DEBUG_STREAM << "RxEmulatorTest::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void RxEmulatorTest::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "RxEmulatorTest::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute rx_mode related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (rx_modeEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RxEmulatorTest::read_rx_mode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RxEmulatorTest::read_rx_mode(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::read_rx_mode) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_rx_mode_read);
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::read_rx_mode
}
//--------------------------------------------------------
/**
 *	Read attribute b1_capabilityState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (b1_capabilityStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RxEmulatorTest::read_b1_capabilityState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RxEmulatorTest::read_b1_capabilityState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::read_b1_capabilityState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_b1_capabilityState_read);
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::read_b1_capabilityState
}
//--------------------------------------------------------
/**
 *	Read attribute b2_capabilityState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (b2_capabilityStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RxEmulatorTest::read_b2_capabilityState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RxEmulatorTest::read_b2_capabilityState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::read_b2_capabilityState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_b2_capabilityState_read);
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::read_b2_capabilityState
}
//--------------------------------------------------------
/**
 *	Read attribute b3_capabilityState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (b3_capabilityStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RxEmulatorTest::read_b3_capabilityState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RxEmulatorTest::read_b3_capabilityState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::read_b3_capabilityState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_b3_capabilityState_read);
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::read_b3_capabilityState
}
//--------------------------------------------------------
/**
 *	Read attribute b4_capabilityState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (b4_capabilityStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RxEmulatorTest::read_b4_capabilityState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RxEmulatorTest::read_b4_capabilityState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::read_b4_capabilityState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_b4_capabilityState_read);
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::read_b4_capabilityState
}
//--------------------------------------------------------
/**
 *	Read attribute b5_capabilityState related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (b5_capabilityStateEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RxEmulatorTest::read_b5_capabilityState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RxEmulatorTest::read_b5_capabilityState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::read_b5_capabilityState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_b5_capabilityState_read);
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::read_b5_capabilityState
}
//--------------------------------------------------------
/**
 *	Read attribute rx_mode_test related method
 *	Description: 
 *
 *	Data type:	Tango::DevEnum (rx_mode_testEnum)
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RxEmulatorTest::read_rx_mode_test(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RxEmulatorTest::read_rx_mode_test(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::read_rx_mode_test) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_rx_mode_test_read);
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::read_rx_mode_test
}
//--------------------------------------------------------
/**
 *	Read attribute configureBandStatus related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2
 */
//--------------------------------------------------------
void RxEmulatorTest::read_configureBandStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RxEmulatorTest::read_configureBandStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(RxEmulatorTest::read_configureBandStatus) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_configureBandStatus_read, 2);
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::read_configureBandStatus
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void RxEmulatorTest::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(RxEmulatorTest::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void RxEmulatorTest::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(RxEmulatorTest::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::add_dynamic_commands
}

/*----- PROTECTED REGION ID(RxEmulatorTest::namespace_ending) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::namespace_ending
} //	namespace
