/*----- PROTECTED REGION ID(RxEmulatorTest.h) ENABLED START -----*/
//=============================================================================
//
// file :        RxEmulatorTest.h
//
// description : Include file for the RxEmulatorTest class
//
// project :     RxEmulatorTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef RxEmulatorTest_H
#define RxEmulatorTest_H

#include <tango.h>


/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest.h

/**
 *  RxEmulatorTest class description:
 *    RxEmulatorTest
 */

namespace RxEmulatorTest_ns
{


enum class _rx_modeEnum : short {
	_UNKNOWN,
	_ERROR,
	_OFF,
	_STARTUP,
	_STANDBYminusLP,
	_STANDBYminusFP,
	_DATAminusCAPTURE,
	_CONFIGURE,
	_MAINTENANCE,
} ;
typedef _rx_modeEnum rx_modeEnum;

enum class _b1_capabilityStateEnum : short {
	_UNKNOWN,
	_UNAVAILABLE,
	_STANDBY,
	_OPERATE,
	_CONFIGURE,
} ;
typedef _b1_capabilityStateEnum b1_capabilityStateEnum;

enum class _b2_capabilityStateEnum : short {
	_UNKNOWN,
	_UNAVAILABLE,
	_STANDBY,
	_OPERATE,
	_CONFIGURE,
} ;
typedef _b2_capabilityStateEnum b2_capabilityStateEnum;

enum class _b3_capabilityStateEnum : short {
	_UNKNOWN,
	_UNAVAILABLE,
	_STANDBY,
	_OPERATE,
	_CONFIGURE,
} ;
typedef _b3_capabilityStateEnum b3_capabilityStateEnum;

enum class _b4_capabilityStateEnum : short {
	_UNKNOWN,
	_UNAVAILABLE,
	_STANDBY,
	_OPERATE,
	_CONFIGURE,
} ;
typedef _b4_capabilityStateEnum b4_capabilityStateEnum;

enum class _b5_capabilityStateEnum : short {
	_UNKNOWN,
	_UNAVAILABLE,
	_STANDBY,
	_OPERATE,
	_CONFIGURE,
} ;
typedef _b5_capabilityStateEnum b5_capabilityStateEnum;

enum class _rx_mode_testEnum : short {
	_UNKNOWN,
	_ERROR,
	_OFF,
	_STARTUP,
	_STANDBYminusLP,
	_STANDBYminusFP,
	_DATAminusCAPTURE,
	_CONFIGURE,
	_MAINTENANCE,
} ;
typedef _rx_mode_testEnum rx_mode_testEnum;

/*----- PROTECTED REGION ID(RxEmulatorTest::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::Additional Class Declarations

class RxEmulatorTest : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(RxEmulatorTest::Data Members) ENABLED START -----*/

//	Add your own data members

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::Data Members


//	Attribute data members
public:
	rx_modeEnum	*attr_rx_mode_read;
	b1_capabilityStateEnum	*attr_b1_capabilityState_read;
	b2_capabilityStateEnum	*attr_b2_capabilityState_read;
	b3_capabilityStateEnum	*attr_b3_capabilityState_read;
	b4_capabilityStateEnum	*attr_b4_capabilityState_read;
	b5_capabilityStateEnum	*attr_b5_capabilityState_read;
	rx_mode_testEnum	*attr_rx_mode_test_read;
	Tango::DevString	*attr_configureBandStatus_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	RxEmulatorTest(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	RxEmulatorTest(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	RxEmulatorTest(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~RxEmulatorTest() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : RxEmulatorTest::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute rx_mode related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_rx_mode(Tango::Attribute &attr);
	virtual bool is_rx_mode_allowed(Tango::AttReqType type);
/**
 *	Attribute b1_capabilityState related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_b1_capabilityState(Tango::Attribute &attr);
	virtual bool is_b1_capabilityState_allowed(Tango::AttReqType type);
/**
 *	Attribute b2_capabilityState related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_b2_capabilityState(Tango::Attribute &attr);
	virtual bool is_b2_capabilityState_allowed(Tango::AttReqType type);
/**
 *	Attribute b3_capabilityState related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_b3_capabilityState(Tango::Attribute &attr);
	virtual bool is_b3_capabilityState_allowed(Tango::AttReqType type);
/**
 *	Attribute b4_capabilityState related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_b4_capabilityState(Tango::Attribute &attr);
	virtual bool is_b4_capabilityState_allowed(Tango::AttReqType type);
/**
 *	Attribute b5_capabilityState related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_b5_capabilityState(Tango::Attribute &attr);
	virtual bool is_b5_capabilityState_allowed(Tango::AttReqType type);
/**
 *	Attribute rx_mode_test related methods
 *	Description: 
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_rx_mode_test(Tango::Attribute &attr);
	virtual bool is_rx_mode_test_allowed(Tango::AttReqType type);
/**
 *	Attribute configureBandStatus related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2
 */
	virtual void read_configureBandStatus(Tango::Attribute &attr);
	virtual bool is_configureBandStatus_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : RxEmulatorTest::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method      : RxEmulatorTest::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(RxEmulatorTest::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::Additional Method prototypes
};

/*----- PROTECTED REGION ID(RxEmulatorTest::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::Additional Classes Definitions

}	//	End of namespace

#endif   //	RxEmulatorTest_H
