/*----- PROTECTED REGION ID(RxEmulatorTestClass.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        RxEmulatorTestClass.cpp
//
// description : C++ source for the RxEmulatorTestClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the RxEmulatorTest once per process.
//
// project :     RxEmulatorTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <RxEmulatorTestClass.h>

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass.cpp

//-------------------------------------------------------------------
/**
 *	Create RxEmulatorTestClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_RxEmulatorTest_class(const char *name) {
		return RxEmulatorTest_ns::RxEmulatorTestClass::init(name);
	}
}

namespace RxEmulatorTest_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
RxEmulatorTestClass *RxEmulatorTestClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		RxEmulatorTestClass::RxEmulatorTestClass(string &s)
 * description : 	constructor for the RxEmulatorTestClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
RxEmulatorTestClass::RxEmulatorTestClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering RxEmulatorTestClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(RxEmulatorTestClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::constructor

	cout2 << "Leaving RxEmulatorTestClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		RxEmulatorTestClass::~RxEmulatorTestClass()
 * description : 	destructor for the RxEmulatorTestClass
 */
//--------------------------------------------------------
RxEmulatorTestClass::~RxEmulatorTestClass()
{
	/*----- PROTECTED REGION ID(RxEmulatorTestClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		RxEmulatorTestClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
RxEmulatorTestClass *RxEmulatorTestClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new RxEmulatorTestClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		RxEmulatorTestClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
RxEmulatorTestClass *RxEmulatorTestClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================

//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTestClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum RxEmulatorTestClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTestClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum RxEmulatorTestClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTestClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum RxEmulatorTestClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTestClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void RxEmulatorTestClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTestClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void RxEmulatorTestClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("RxEmulatorTest");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("RxEmulatorTest");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTestClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void RxEmulatorTestClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(RxEmulatorTestClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new RxEmulatorTest(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		RxEmulatorTest *dev = static_cast<RxEmulatorTest *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(RxEmulatorTestClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTestClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void RxEmulatorTestClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(RxEmulatorTestClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::attribute_factory_before
	//	Attribute : rx_mode
	rx_modeAttrib	*rx_mode = new rx_modeAttrib();
	Tango::UserDefaultAttrProp	rx_mode_prop;
	//	description	not set for rx_mode
	//	label	not set for rx_mode
	//	unit	not set for rx_mode
	//	standard_unit	not set for rx_mode
	//	display_unit	not set for rx_mode
	//	format	not set for rx_mode
	//	max_value	not set for rx_mode
	//	min_value	not set for rx_mode
	//	max_alarm	not set for rx_mode
	//	min_alarm	not set for rx_mode
	//	max_warning	not set for rx_mode
	//	min_warning	not set for rx_mode
	//	delta_t	not set for rx_mode
	//	delta_val	not set for rx_mode
	rx_mode_prop.set_event_period("1000");
	
	{
		vector<string> labels;
		labels.push_back("UNKNOWN");
		labels.push_back("ERROR");
		labels.push_back("OFF");
		labels.push_back("STARTUP");
		labels.push_back("STANDBY-LP");
		labels.push_back("STANDBY-FP");
		labels.push_back("DATA-CAPTURE");
		labels.push_back("CONFIGURE");
		labels.push_back("MAINTENANCE");
		rx_mode_prop.set_enum_labels(labels);
	}
	rx_mode->set_default_properties(rx_mode_prop);
	rx_mode->set_polling_period(1000);
	rx_mode->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	rx_mode->set_change_event(true, false);
	att_list.push_back(rx_mode);

	//	Attribute : b1_capabilityState
	b1_capabilityStateAttrib	*b1_capabilitystate = new b1_capabilityStateAttrib();
	Tango::UserDefaultAttrProp	b1_capabilitystate_prop;
	//	description	not set for b1_capabilityState
	//	label	not set for b1_capabilityState
	//	unit	not set for b1_capabilityState
	//	standard_unit	not set for b1_capabilityState
	//	display_unit	not set for b1_capabilityState
	//	format	not set for b1_capabilityState
	//	max_value	not set for b1_capabilityState
	//	min_value	not set for b1_capabilityState
	//	max_alarm	not set for b1_capabilityState
	//	min_alarm	not set for b1_capabilityState
	//	max_warning	not set for b1_capabilityState
	//	min_warning	not set for b1_capabilityState
	//	delta_t	not set for b1_capabilityState
	//	delta_val	not set for b1_capabilityState
	b1_capabilitystate_prop.set_event_period("1000");
	
	{
		vector<string> labels;
		labels.push_back("UNKNOWN");
		labels.push_back("UNAVAILABLE");
		labels.push_back("STANDBY");
		labels.push_back("OPERATE");
		labels.push_back("CONFIGURE");
		b1_capabilitystate_prop.set_enum_labels(labels);
	}
	b1_capabilitystate->set_default_properties(b1_capabilitystate_prop);
	b1_capabilitystate->set_polling_period(1000);
	b1_capabilitystate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	b1_capabilitystate->set_change_event(true, false);
	att_list.push_back(b1_capabilitystate);

	//	Attribute : b2_capabilityState
	b2_capabilityStateAttrib	*b2_capabilitystate = new b2_capabilityStateAttrib();
	Tango::UserDefaultAttrProp	b2_capabilitystate_prop;
	//	description	not set for b2_capabilityState
	//	label	not set for b2_capabilityState
	//	unit	not set for b2_capabilityState
	//	standard_unit	not set for b2_capabilityState
	//	display_unit	not set for b2_capabilityState
	//	format	not set for b2_capabilityState
	//	max_value	not set for b2_capabilityState
	//	min_value	not set for b2_capabilityState
	//	max_alarm	not set for b2_capabilityState
	//	min_alarm	not set for b2_capabilityState
	//	max_warning	not set for b2_capabilityState
	//	min_warning	not set for b2_capabilityState
	//	delta_t	not set for b2_capabilityState
	//	delta_val	not set for b2_capabilityState
	b2_capabilitystate_prop.set_event_period("1000");
	
	{
		vector<string> labels;
		labels.push_back("UNKNOWN");
		labels.push_back("UNAVAILABLE");
		labels.push_back("STANDBY");
		labels.push_back("OPERATE");
		labels.push_back("CONFIGURE");
		b2_capabilitystate_prop.set_enum_labels(labels);
	}
	b2_capabilitystate->set_default_properties(b2_capabilitystate_prop);
	b2_capabilitystate->set_polling_period(1000);
	b2_capabilitystate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	b2_capabilitystate->set_change_event(true, false);
	att_list.push_back(b2_capabilitystate);

	//	Attribute : b3_capabilityState
	b3_capabilityStateAttrib	*b3_capabilitystate = new b3_capabilityStateAttrib();
	Tango::UserDefaultAttrProp	b3_capabilitystate_prop;
	//	description	not set for b3_capabilityState
	//	label	not set for b3_capabilityState
	//	unit	not set for b3_capabilityState
	//	standard_unit	not set for b3_capabilityState
	//	display_unit	not set for b3_capabilityState
	//	format	not set for b3_capabilityState
	//	max_value	not set for b3_capabilityState
	//	min_value	not set for b3_capabilityState
	//	max_alarm	not set for b3_capabilityState
	//	min_alarm	not set for b3_capabilityState
	//	max_warning	not set for b3_capabilityState
	//	min_warning	not set for b3_capabilityState
	//	delta_t	not set for b3_capabilityState
	//	delta_val	not set for b3_capabilityState
	b3_capabilitystate_prop.set_event_period("1000");
	
	{
		vector<string> labels;
		labels.push_back("UNKNOWN");
		labels.push_back("UNAVAILABLE");
		labels.push_back("STANDBY");
		labels.push_back("OPERATE");
		labels.push_back("CONFIGURE");
		b3_capabilitystate_prop.set_enum_labels(labels);
	}
	b3_capabilitystate->set_default_properties(b3_capabilitystate_prop);
	b3_capabilitystate->set_polling_period(1000);
	b3_capabilitystate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	b3_capabilitystate->set_change_event(true, false);
	att_list.push_back(b3_capabilitystate);

	//	Attribute : b4_capabilityState
	b4_capabilityStateAttrib	*b4_capabilitystate = new b4_capabilityStateAttrib();
	Tango::UserDefaultAttrProp	b4_capabilitystate_prop;
	//	description	not set for b4_capabilityState
	//	label	not set for b4_capabilityState
	//	unit	not set for b4_capabilityState
	//	standard_unit	not set for b4_capabilityState
	//	display_unit	not set for b4_capabilityState
	//	format	not set for b4_capabilityState
	//	max_value	not set for b4_capabilityState
	//	min_value	not set for b4_capabilityState
	//	max_alarm	not set for b4_capabilityState
	//	min_alarm	not set for b4_capabilityState
	//	max_warning	not set for b4_capabilityState
	//	min_warning	not set for b4_capabilityState
	//	delta_t	not set for b4_capabilityState
	//	delta_val	not set for b4_capabilityState
	b4_capabilitystate_prop.set_event_period("1000");
	
	{
		vector<string> labels;
		labels.push_back("UNKNOWN");
		labels.push_back("UNAVAILABLE");
		labels.push_back("StANDBY");
		labels.push_back("OPERATE");
		labels.push_back("CONFIGURE");
		b4_capabilitystate_prop.set_enum_labels(labels);
	}
	b4_capabilitystate->set_default_properties(b4_capabilitystate_prop);
	b4_capabilitystate->set_polling_period(1000);
	b4_capabilitystate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	b4_capabilitystate->set_change_event(true, false);
	att_list.push_back(b4_capabilitystate);

	//	Attribute : b5_capabilityState
	b5_capabilityStateAttrib	*b5_capabilitystate = new b5_capabilityStateAttrib();
	Tango::UserDefaultAttrProp	b5_capabilitystate_prop;
	//	description	not set for b5_capabilityState
	//	label	not set for b5_capabilityState
	//	unit	not set for b5_capabilityState
	//	standard_unit	not set for b5_capabilityState
	//	display_unit	not set for b5_capabilityState
	//	format	not set for b5_capabilityState
	//	max_value	not set for b5_capabilityState
	//	min_value	not set for b5_capabilityState
	//	max_alarm	not set for b5_capabilityState
	//	min_alarm	not set for b5_capabilityState
	//	max_warning	not set for b5_capabilityState
	//	min_warning	not set for b5_capabilityState
	//	delta_t	not set for b5_capabilityState
	//	delta_val	not set for b5_capabilityState
	b5_capabilitystate_prop.set_event_period("1000");
	
	{
		vector<string> labels;
		labels.push_back("UNKNOWN");
		labels.push_back("UNAVAILABLE");
		labels.push_back("STANDBY");
		labels.push_back("OPERATE");
		labels.push_back("CONFIGURE");
		b5_capabilitystate_prop.set_enum_labels(labels);
	}
	b5_capabilitystate->set_default_properties(b5_capabilitystate_prop);
	b5_capabilitystate->set_polling_period(1000);
	b5_capabilitystate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	b5_capabilitystate->set_change_event(true, false);
	att_list.push_back(b5_capabilitystate);

	//	Attribute : rx_mode_test
	rx_mode_testAttrib	*rx_mode_test = new rx_mode_testAttrib();
	Tango::UserDefaultAttrProp	rx_mode_test_prop;
	//	description	not set for rx_mode_test
	//	label	not set for rx_mode_test
	//	unit	not set for rx_mode_test
	//	standard_unit	not set for rx_mode_test
	//	display_unit	not set for rx_mode_test
	//	format	not set for rx_mode_test
	//	max_value	not set for rx_mode_test
	//	min_value	not set for rx_mode_test
	//	max_alarm	not set for rx_mode_test
	//	min_alarm	not set for rx_mode_test
	//	max_warning	not set for rx_mode_test
	//	min_warning	not set for rx_mode_test
	//	delta_t	not set for rx_mode_test
	//	delta_val	not set for rx_mode_test
	rx_mode_test_prop.set_event_period("1000");
	
	{
		vector<string> labels;
		labels.push_back("UNKNOWN");
		labels.push_back("ERROR");
		labels.push_back("OFF");
		labels.push_back("STARTUP");
		labels.push_back("STANDBY-LP");
		labels.push_back("STANDBY-FP");
		labels.push_back("DATA-CAPTURE");
		labels.push_back("CONFIGURE");
		labels.push_back("MAINTENANCE");
		rx_mode_test_prop.set_enum_labels(labels);
	}
	rx_mode_test->set_default_properties(rx_mode_test_prop);
	rx_mode_test->set_polling_period(1000);
	rx_mode_test->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	rx_mode_test->set_change_event(true, false);
	att_list.push_back(rx_mode_test);

	//	Attribute : configureBandStatus
	configureBandStatusAttrib	*configurebandstatus = new configureBandStatusAttrib();
	Tango::UserDefaultAttrProp	configurebandstatus_prop;
	//	description	not set for configureBandStatus
	//	label	not set for configureBandStatus
	//	unit	not set for configureBandStatus
	//	standard_unit	not set for configureBandStatus
	//	display_unit	not set for configureBandStatus
	//	format	not set for configureBandStatus
	//	max_value	not set for configureBandStatus
	//	min_value	not set for configureBandStatus
	//	max_alarm	not set for configureBandStatus
	//	min_alarm	not set for configureBandStatus
	//	max_warning	not set for configureBandStatus
	//	min_warning	not set for configureBandStatus
	//	delta_t	not set for configureBandStatus
	//	delta_val	not set for configureBandStatus
	configurebandstatus_prop.set_event_period("3000");
	
	configurebandstatus->set_default_properties(configurebandstatus_prop);
	configurebandstatus->set_polling_period(3000);
	configurebandstatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	configurebandstatus->set_change_event(true, false);
	att_list.push_back(configurebandstatus);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(RxEmulatorTestClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTestClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void RxEmulatorTestClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(RxEmulatorTestClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::pipe_factory_before
	/*----- PROTECTED REGION ID(RxEmulatorTestClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTestClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void RxEmulatorTestClass::command_factory()
{
	/*----- PROTECTED REGION ID(RxEmulatorTestClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::command_factory_before


	/*----- PROTECTED REGION ID(RxEmulatorTestClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		RxEmulatorTestClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void RxEmulatorTestClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(RxEmulatorTestClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		RxEmulatorTestClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void RxEmulatorTestClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		RxEmulatorTest *dev = static_cast<RxEmulatorTest *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(RxEmulatorTestClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTestClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *RxEmulatorTestClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(RxEmulatorTestClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTestClass::Additional Methods
} //	namespace
