/*----- PROTECTED REGION ID(RxEmulatorTestStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        RxEmulatorTestStateMachine.cpp
//
// description : State machine file for the RxEmulatorTest class
//
// project :     RxEmulatorTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <RxEmulatorTest.h>

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::RxEmulatorTestStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace RxEmulatorTest_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::is_rx_mode_allowed()
 *	Description : Execution allowed for rx_mode attribute
 */
//--------------------------------------------------------
bool RxEmulatorTest::is_rx_mode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for rx_mode attribute in read access.
	/*----- PROTECTED REGION ID(RxEmulatorTest::rx_modeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::rx_modeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::is_b1_capabilityState_allowed()
 *	Description : Execution allowed for b1_capabilityState attribute
 */
//--------------------------------------------------------
bool RxEmulatorTest::is_b1_capabilityState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for b1_capabilityState attribute in read access.
	/*----- PROTECTED REGION ID(RxEmulatorTest::b1_capabilityStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::b1_capabilityStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::is_b2_capabilityState_allowed()
 *	Description : Execution allowed for b2_capabilityState attribute
 */
//--------------------------------------------------------
bool RxEmulatorTest::is_b2_capabilityState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for b2_capabilityState attribute in read access.
	/*----- PROTECTED REGION ID(RxEmulatorTest::b2_capabilityStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::b2_capabilityStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::is_b3_capabilityState_allowed()
 *	Description : Execution allowed for b3_capabilityState attribute
 */
//--------------------------------------------------------
bool RxEmulatorTest::is_b3_capabilityState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for b3_capabilityState attribute in read access.
	/*----- PROTECTED REGION ID(RxEmulatorTest::b3_capabilityStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::b3_capabilityStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::is_b4_capabilityState_allowed()
 *	Description : Execution allowed for b4_capabilityState attribute
 */
//--------------------------------------------------------
bool RxEmulatorTest::is_b4_capabilityState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for b4_capabilityState attribute in read access.
	/*----- PROTECTED REGION ID(RxEmulatorTest::b4_capabilityStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::b4_capabilityStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::is_b5_capabilityState_allowed()
 *	Description : Execution allowed for b5_capabilityState attribute
 */
//--------------------------------------------------------
bool RxEmulatorTest::is_b5_capabilityState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for b5_capabilityState attribute in read access.
	/*----- PROTECTED REGION ID(RxEmulatorTest::b5_capabilityStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::b5_capabilityStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::is_rx_mode_test_allowed()
 *	Description : Execution allowed for rx_mode_test attribute
 */
//--------------------------------------------------------
bool RxEmulatorTest::is_rx_mode_test_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for rx_mode_test attribute in read access.
	/*----- PROTECTED REGION ID(RxEmulatorTest::rx_mode_testStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::rx_mode_testStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : RxEmulatorTest::is_configureBandStatus_allowed()
 *	Description : Execution allowed for configureBandStatus attribute
 */
//--------------------------------------------------------
bool RxEmulatorTest::is_configureBandStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for configureBandStatus attribute in read access.
	/*----- PROTECTED REGION ID(RxEmulatorTest::configureBandStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::configureBandStatusStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================


/*----- PROTECTED REGION ID(RxEmulatorTest::RxEmulatorTestStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	RxEmulatorTest::RxEmulatorTestStateAllowed.AdditionalMethods

}	//	End of namespace
