/*----- PROTECTED REGION ID(SPFEmulatorTestClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        SPFEmulatorTestClass.h
//
// description : Include for the SPFEmulatorTest root class.
//               This class is the singleton class for
//                the SPFEmulatorTest device class.
//               It contains all properties and methods which the 
//               SPFEmulatorTest requires only once e.g. the commands.
//
// project :     SPFEmulatorTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef SPFEmulatorTestClass_H
#define SPFEmulatorTestClass_H

#include <tango.h>
#include <SPFEmulatorTest.h>


/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTestClass.h


namespace SPFEmulatorTest_ns
{
/*----- PROTECTED REGION ID(SPFEmulatorTestClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTestClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute spf_mode class definition
class spf_modeAttrib: public Tango::Attr
{
public:
	spf_modeAttrib():Attr("spf_mode",
			Tango::DEV_ENUM, Tango::READ) {};
	~spf_modeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SPFEmulatorTest *>(dev))->read_spf_mode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SPFEmulatorTest *>(dev))->is_spf_mode_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(spf_modeEnum) == in_type;}
	virtual string get_enum_type() {return string("spf_modeEnum");}
};

//	Attribute b1_capabilityState class definition
class b1_capabilityStateAttrib: public Tango::Attr
{
public:
	b1_capabilityStateAttrib():Attr("b1_capabilityState",
			Tango::DEV_ENUM, Tango::READ) {};
	~b1_capabilityStateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SPFEmulatorTest *>(dev))->read_b1_capabilityState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SPFEmulatorTest *>(dev))->is_b1_capabilityState_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(b1_capabilityStateEnum) == in_type;}
	virtual string get_enum_type() {return string("b1_capabilityStateEnum");}
};

//	Attribute b2_capabilityState class definition
class b2_capabilityStateAttrib: public Tango::Attr
{
public:
	b2_capabilityStateAttrib():Attr("b2_capabilityState",
			Tango::DEV_ENUM, Tango::READ) {};
	~b2_capabilityStateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SPFEmulatorTest *>(dev))->read_b2_capabilityState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SPFEmulatorTest *>(dev))->is_b2_capabilityState_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(b2_capabilityStateEnum) == in_type;}
	virtual string get_enum_type() {return string("b2_capabilityStateEnum");}
};

//	Attribute b3_capabilityState class definition
class b3_capabilityStateAttrib: public Tango::Attr
{
public:
	b3_capabilityStateAttrib():Attr("b3_capabilityState",
			Tango::DEV_ENUM, Tango::READ) {};
	~b3_capabilityStateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SPFEmulatorTest *>(dev))->read_b3_capabilityState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SPFEmulatorTest *>(dev))->is_b3_capabilityState_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(b3_capabilityStateEnum) == in_type;}
	virtual string get_enum_type() {return string("b3_capabilityStateEnum");}
};

//	Attribute b4_capabilityState class definition
class b4_capabilityStateAttrib: public Tango::Attr
{
public:
	b4_capabilityStateAttrib():Attr("b4_capabilityState",
			Tango::DEV_ENUM, Tango::READ) {};
	~b4_capabilityStateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SPFEmulatorTest *>(dev))->read_b4_capabilityState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SPFEmulatorTest *>(dev))->is_b4_capabilityState_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(b4_capabilityStateEnum) == in_type;}
	virtual string get_enum_type() {return string("b4_capabilityStateEnum");}
};

//	Attribute b5_capabilityState class definition
class b5_capabilityStateAttrib: public Tango::Attr
{
public:
	b5_capabilityStateAttrib():Attr("b5_capabilityState",
			Tango::DEV_ENUM, Tango::READ) {};
	~b5_capabilityStateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SPFEmulatorTest *>(dev))->read_b5_capabilityState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SPFEmulatorTest *>(dev))->is_b5_capabilityState_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(b5_capabilityStateEnum) == in_type;}
	virtual string get_enum_type() {return string("b5_capabilityStateEnum");}
};

//	Attribute spf_mode_test class definition
class spf_mode_testAttrib: public Tango::Attr
{
public:
	spf_mode_testAttrib():Attr("spf_mode_test",
			Tango::DEV_ENUM, Tango::READ) {};
	~spf_mode_testAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SPFEmulatorTest *>(dev))->read_spf_mode_test(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SPFEmulatorTest *>(dev))->is_spf_mode_test_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(spf_mode_testEnum) == in_type;}
	virtual string get_enum_type() {return string("spf_mode_testEnum");}
};

//	Attribute operateStatus class definition
class operateStatusAttrib: public Tango::SpectrumAttr
{
public:
	operateStatusAttrib():SpectrumAttr("operateStatus",
			Tango::DEV_STRING, Tango::READ, 2) {};
	~operateStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SPFEmulatorTest *>(dev))->read_operateStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SPFEmulatorTest *>(dev))->is_operateStatus_allowed(ty);}
};


/**
 *	The SPFEmulatorTestClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  SPFEmulatorTestClass : public Tango::DeviceClass
#else
class SPFEmulatorTestClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(SPFEmulatorTestClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTestClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static SPFEmulatorTestClass *init(const char *);
		static SPFEmulatorTestClass *instance();
		~SPFEmulatorTestClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		SPFEmulatorTestClass(string &);
		static SPFEmulatorTestClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	SPFEmulatorTest_H
