/*----- PROTECTED REGION ID(SPFEmulatorTestStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        SPFEmulatorTestStateMachine.cpp
//
// description : State machine file for the SPFEmulatorTest class
//
// project :     SPFEmulatorTest
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <SPFEmulatorTest.h>

/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::SPFEmulatorTestStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace SPFEmulatorTest_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::is_spf_mode_allowed()
 *	Description : Execution allowed for spf_mode attribute
 */
//--------------------------------------------------------
bool SPFEmulatorTest::is_spf_mode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for spf_mode attribute in read access.
	/*----- PROTECTED REGION ID(SPFEmulatorTest::spf_modeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::spf_modeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::is_b1_capabilityState_allowed()
 *	Description : Execution allowed for b1_capabilityState attribute
 */
//--------------------------------------------------------
bool SPFEmulatorTest::is_b1_capabilityState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for b1_capabilityState attribute in read access.
	/*----- PROTECTED REGION ID(SPFEmulatorTest::b1_capabilityStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::b1_capabilityStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::is_b2_capabilityState_allowed()
 *	Description : Execution allowed for b2_capabilityState attribute
 */
//--------------------------------------------------------
bool SPFEmulatorTest::is_b2_capabilityState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for b2_capabilityState attribute in read access.
	/*----- PROTECTED REGION ID(SPFEmulatorTest::b2_capabilityStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::b2_capabilityStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::is_b3_capabilityState_allowed()
 *	Description : Execution allowed for b3_capabilityState attribute
 */
//--------------------------------------------------------
bool SPFEmulatorTest::is_b3_capabilityState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for b3_capabilityState attribute in read access.
	/*----- PROTECTED REGION ID(SPFEmulatorTest::b3_capabilityStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::b3_capabilityStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::is_b4_capabilityState_allowed()
 *	Description : Execution allowed for b4_capabilityState attribute
 */
//--------------------------------------------------------
bool SPFEmulatorTest::is_b4_capabilityState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for b4_capabilityState attribute in read access.
	/*----- PROTECTED REGION ID(SPFEmulatorTest::b4_capabilityStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::b4_capabilityStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::is_b5_capabilityState_allowed()
 *	Description : Execution allowed for b5_capabilityState attribute
 */
//--------------------------------------------------------
bool SPFEmulatorTest::is_b5_capabilityState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for b5_capabilityState attribute in read access.
	/*----- PROTECTED REGION ID(SPFEmulatorTest::b5_capabilityStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::b5_capabilityStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::is_spf_mode_test_allowed()
 *	Description : Execution allowed for spf_mode_test attribute
 */
//--------------------------------------------------------
bool SPFEmulatorTest::is_spf_mode_test_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for spf_mode_test attribute in read access.
	/*----- PROTECTED REGION ID(SPFEmulatorTest::spf_mode_testStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::spf_mode_testStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SPFEmulatorTest::is_operateStatus_allowed()
 *	Description : Execution allowed for operateStatus attribute
 */
//--------------------------------------------------------
bool SPFEmulatorTest::is_operateStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for operateStatus attribute in read access.
	/*----- PROTECTED REGION ID(SPFEmulatorTest::operateStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::operateStatusStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================


/*----- PROTECTED REGION ID(SPFEmulatorTest::SPFEmulatorTestStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	SPFEmulatorTest::SPFEmulatorTestStateAllowed.AdditionalMethods

}	//	End of namespace
